// Random oj uz submit
// Идея: idk

#include "timetravel.h"

#include<bits/stdc++.h>
using namespace std;

int encode (int n, int x, int y) {
    for(int i = 0; i < 5; i++) {
        if(x%5 != y%5) {
            int ans = i*4,a = x%5,b = y%5,c;
            if(a < 4 && b < 4) {
                if((b+1)%4 == a) {
                    c = (a+1)%4;
                }
                else {
                    c = a;
                }
            }
            else if(a == 4) {
                if(b%2) {
                    c = (b+3)%4;
                }
                else {
                    c = (b+2)%4;
                }
            }
            else if(b == 4) {
                if(a%2 == 0) {
                    c = (a+1)%4;
                }
                else {
                    c = a;
                }
            }
            return ans+c+1;
        }
        x/=5;
        y/=5;
    }
}

bool answer(int n, int q, int h) {
    h--;
    for(int i = 0; i < h/4; i++) {
        q/=5;
    }
    h%=4;
    q%=5;
    if(q == 4) {
        if(h%2) {
            return 0;
        }
        else {
            return 1;
        }
    }
    else {
        if(q == h || (q+1)%4 == h) {
            return 1;
        }
        else {
            return 0;
        }
    }
}
